<h1>Список комплексных задач</h1>
<input type="button" value="Добавить" class="btn btn-light" (click)="add()" />
<h3>Всего в таблице элементов {{epicTaskCount}}</h3>
<table *ngIf="tableMode; else create" class="table table-striped">
    <thead>
        <tr>
            <td>Id</td>
            <td>Заголовок</td>
            <td>Описание</td>
            <td>UserId</td>
        </tr>
    </thead>
    <tbody>
        <tr *ngFor="let i of epicTasks">
            <ng-template [ngIf]="epicTask?.id != i.id" [ngIfElse]="edit">
                <td width="20%">{{i?.id}}</td>
                <td width="20%">{{i?.title}}</td>
                <td width="20%">{{i?.description}}</td>
                <td width="20%">{{i?.userId}}</td>
                <td width="20%">
                    <button class="btn btn-sm btn-primary" (click)="editEpicTask(i)">Изменить</button>
                    <button class="btn btn-sm btn-danger" (click)="deleteEpicTask(i)">Удалить</button>
                </td>
            </ng-template>
        </tr>
    </tbody>
</table>
<ngb-pagination *ngIf="tableMode" class="d-flex justify-content-center" [collectionSize]="epicTaskCount" [pageSize]="pageSize" [(page)]="page" [boundaryLinks]="true" (pageChange)="onPageChanged($event)"></ngb-pagination>


<!--шаблон для редактирования-->
<ng-template #edit>
    <td>
        <input type="text" disabled [ngModel]="epicTask.id" class="form-control" />
    </td>
    <td>
        <input #title="ngModel" required pattern="^[^а-яА-Я]+$" type="text" [(ngModel)]="epicTask.title" class="form-control" />
        <div class="alert alert-danger" [hidden]="title.valid || title.pristine">
            Заголовок не может содержать русских букв
        </div>
    </td>
    <td>
        <input #description="ngModel" required pattern="^[^а-яА-Я]+$" type="text" [(ngModel)]="epicTask.description" class="form-control" />
        <div class="alert alert-danger" [hidden]="description.valid || description.pristine">
            Описание не может содержать русских букв
        </div>
    </td>
    <td>
        <input #userId="ngModel" required pattern="^[1-9]\d*$" type="text" [(ngModel)]="epicTask.userId" class="form-control" />
        <div class="alert alert-danger" [hidden]="userId.valid || userId.pristine">
            Идентификатор пользователя должен быть натуральным числом
        </div>
    </td>
    <td width="20%">
        <input type="button" [disabled]="!title.valid || !description.valid || !userId.valid" value="Сохранить" (click)="updateEpicTask()" class="btn btn-sm btn-success" />
        <input type="button" value="Отмена" (click)="cancelEditEpicTask()" class="btn btn-sm btn-warning" />
    </td>
</ng-template>

<!--шаблон для добавления-->
<ng-template #create>
    <div class="form-group">
        <label>Заголовок</label>
        <input #title="ngModel" required pattern="^[^а-яА-Я]+$" type="text" [(ngModel)]="epicTask.title" class="form-control" />
        <div class="alert alert-danger" [hidden]="title.valid || title.pristine">
            Заголовок не может содержать русских букв
        </div>
    </div>
    <div class="form-group">
        <label>Описание</label>
        <input #description="ngModel" required pattern="^[^а-яА-Я]+$" type="text" [(ngModel)]="epicTask.description" class="form-control" />
        <div class="alert alert-danger" [hidden]="description.valid || description.pristine">
            Описание не может содержать русских букв
        </div>
    </div>
    <div class="form-group">
        <label>Идентификатор пользователя</label>
        <input #userId="ngModel" required pattern="^[1-9]\d*$" type="text" [(ngModel)]="epicTask.userId" class="form-control" />
        <div class="alert alert-danger" [hidden]="userId.valid || userId.pristine">
            Идентификатор пользователя должен быть натуральным числом
        </div>
    </div>
    <div>
        <input type="button" [disabled]="!title.valid || !description.valid || !userId.valid" value="Сохранить" (click)="createEpicTask()" class="btn btn-success" />
        <input type="button" value="Отмена" (click)="cancelAddEpicTask()" class="btn btn-warning" />
    </div>
</ng-template>